unit UTRasterizer;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, RGBGraphics, RGBTypes;

Type
    TRasterizer = class(TThread)
    private
      fStatusText : string;
      procedure ShowStatus;
    protected
      procedure Execute; override;
    public
       Constructor Create(CreateSuspended : boolean);
    end;

implementation
uses Unit1;

  constructor TMyThread.Create(CreateSuspended : boolean);
  begin
    FreeOnTerminate := True;
    inherited Create(CreateSuspended);
  end;

  procedure TMyThread.ShowStatus;
  begin
       Form1.Invalidate;
  end;

  procedure TMyThread.Execute;
  var
    u, i, k, ThreadI, ThreadK: integer;
    xw, yw, Pwidth, PHalfWidth, rem1, rem2: integer;
    cl: TRGB32Pixel;
    valid: boolean;
  begin
    PWidth:=27;
    u:=SizeY;
    while true do
    begin
    PHalfWidth:=trunc(PWidth/2);
    Threadi:=PHalfWidth;
    yw:=PHalfWidth;
    while Threadi<SizeY do
    begin
         Threadk:=PHalfWidth;
         xW:=PHalfWidth;
         while Threadk<SizeX do
         begin
              if ((ThreadI+ThreadK+2) mod PWidth<>0) then valid:=true
              else begin
                   rem1:=(ThreadI+1) div PWidth;
                   rem2:=(Threadk+1) div PWidth;
                   if (rem1 mod 3<>0) and (rem2 mod 3<>0) then valid:=false
                   else valid:=true;
              end;
              if valid=true then begin
                 cl:=GetMandelbrot(Threadk,Threadi);
                 for i:=ThreadI-yw to ThreadI+yw do
                     for k:=Threadk-xw to ThreadK+xw do
                         RGBBitmap.Set32Pixel(k,i,cl);
              end;
              if ThreadK<SizeX-PWidth-1 then inc(Threadk,PWidth)
              else begin
                   inc(ThreadK);
                   xw:=1;
              end;
         end;
         if ThreadI<SizeY-PWidth-1 then inc(ThreadI,PWidth)
         else begin
              inc(Threadi);
              yw:=1;
         end;
         if ThreadI mod u=0 then Synchronize(@Showstatus);
     end;
     Synchronize(@Showstatus);
     if PWidth=1 then break
     else PWidth:=PWidth div 3;
     u:=u div 3;
     end;
  end;

end.

