unit UErrorHandling;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils;

type
  ECParserException = class(Exception);

procedure RaiseError(E: byte; p: integer = 0; l: integer = 1);

var
  FGLastErrorMessage: string;
  FGLastErrorPosition: integer;
  FGLastErrorLength: integer;

implementation

procedure RaiseError(E: byte; p: integer = 0; l: integer = 1);
const
  sF0 = 'Parser: Zu wenig oder zu viele Klammern gesetzt.';
  sF1 = 'Parser: Leerer String als Eingabe!';
  sf2 = 'Parser: Unbekanntes Zeichen in Eingabe!';
  sF3 = 'Parser: Fehlerhaftes Konstrukt!';
var
  Error: Exception;
begin
  if E >= $F0 then
  begin
    case E of
      $F0: FGLastErrorMessage := sF0;
      $F1: FGLastErrorMessage := sF1;
      $F2: FGLastErrorMessage := sF2;
      $F3: FGLastErrorMessage := sF3;
    end;
    Error := ECParserException.Create(FGLastErrorMessage);
    FGLastErrorPosition := p;
    FGLastErrorLength := l;
  end;
  Raise Error;
end;

end.

