unit UTFractalGenerator;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, lcltype, Forms, Controls, Graphics,
  Dialogs, ExtCtrls, StdCtrls, process, EditBtn, ComCtrls, Buttons,
  Menus, Spin, Math, OpenGLContext, GL, UOGL, SynEdit, SynMemo,
  UTPixel, UTComplex, UTFractal, UErrorHandling, UTOrbitTracer,
  UTRasterizer, FPImage, FPWritePNG;

type

  { TFG }

  TFG = class(TForm)
   cmb_calculatingmode: TComboBox;
   syned_critical: TSynMemo;

    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure UpdateControls;
    //liest Werte aus Fractal und füttert die Kontrollelemente damit
    procedure UpdateFractal;
    //liest Werte aus den Kontrollelementen und füttert Fractal damit

  //++++++++++Menu++++++++++
    men_Main: TMainMenu;
      men_file: TMenuItem;    //Datei
          men_file_loadfractal: TMenuItem;
          procedure men_file_loadfractalClick(Sender: TObject);
          men_file_savefractal: TMenuItem;
          procedure men_file_savefractalClick(Sender: TObject);
          men_file_savebmp: TMenuItem;    //Bild speichern
          procedure men_file_savebmpClick(Sender: TObject);
          PictureSaveDialog: TSaveDialog;
      men_tools: TMenuItem;
          men_tracer: TMenuItem;
          procedure men_tracerClick(Sender: TObject);

    MainPage: TPageControl; //Tab-Interface
  //1. Seite :
  //++++++++++Fractalerzeugung++++++++++
  pge_properties: TTabSheet;
    but_generate: TButton;
    procedure but_generateClick(Sender: TObject);

    //++++++++++Parameter++++++++++
    ced_size: TGroupBox;      //Maße des Bildausschnitts
    ced_sizeI: TFloatSpinEdit;
    lbl_Sizei1: TLabel;
    ced_sizeR: TFloatSpinEdit;
    lbl_sizeR1: TLabel;

    ced_size_pixels: TGroupBox; //Maße des Bildausschnitts de
    ced_size_pixelsR: TSpinEdit;
    lbl_size_pixelsR: TLabel;
    ced_size_pixelsI: TSpinEdit;
    lbl_Size_pixelsI: TLabel;

    ced_center: TGroupBox;    //Mitte des Bildausschnitts
    ced_centerR: TFloatSpinEdit;
    lbl_centerR: TLabel;
    ced_centerI: TFloatSpinEdit;
    lbl_centerI: TLabel;

    ced_iterations: TGroupBox;  //Iterationen
    ced_MaxIter: TSpinEdit;

    sed_dwell: TFloatSpinEdit;  //Grenze Lyapunov-Exponent
    lbl_dwell: TLabel;

    grp_calcmode: TGroupBox;
    //1 - LyapunovPeriods, 2 - Lyapunov(exakt), 3 - BoiloutPeriods
    //4 - Boilout
    sed_maxLya: TSpinEdit;
    lbl_Maxlya: TLabel;  //LyaUpperBorder
    sed_minLya: TSpinEdit;
    lbl_MinLya: TLabel;  //LyaLowerBorder
    sed_cycPoints: TSpinEdit;
    lbl_cycPoints: TLabel; //MinCycPoints

  //2. Seite :
  //++++++++++Parser++++++++++
  pge_formula: TTabSheet;
    but_parse: TButton; //liest Formel ein und generiert die Parser
    procedure but_parseClick(Sender: TObject);
    // 1 - Mandelbrot, 2 - Parserformel
    syned_formula: TSynMemo;
    lbl_critical: TLabel;
    ed_dem: TEdit;      //DEM-Iteration
    lbl_dem: TLabel;
    ed_derivate2: TEdit; //2. Ableitung
    lbl_derivate2: TLabel;
    lbl_formula: TLabel;
    ed_derivate: TEdit;  //1. Ableitung
    lbl_derivate: TLabel;

  //3. Seite :
  //++++++++++Farbmenu++++++++++
  pge_colors: TTabSheet;
    //++++++++++Außenfärbung++++++++++
    grp_Outercolors: TGroupBox;
    cmb_outercolormode: TComboBox;  //Außenfärbung
    procedure cmb_outercolormodeChange(Sender: TObject);
    //itemindex = 1 - LN, 2 - LNSW
    sed_colorrepeat: TSpinEdit; //wiederholt den Farbverlauf
    procedure sed_colorrepeatChange(Sender: TObject);
    lbl_colorrepeat: TLabel;
    chk_invertcolors: TCheckBox;  //dreht Farbverlauf um
    procedure chk_invertcolorsChange(Sender: TObject);

    procedure DrawOuterColors;
    img_OuterColors: TImage;      //zeigt Farbwahlmenü an
    //bmp_OuterColors: TBitmap;
    //zweiter Buffer für flickerfreies Verschieben der Wahlpunkte
    HSL_Table: TBitmap;
    //dritter Buffer, enthält nur das Hintergrundbild, den HSL-Verlauf

    //++++++++++Farbpicker++++++++++
    procedure img_OuterColorsMouseDown(Sender: TObject; Button: TMouseButton;
     Shift: TShiftState; X, Y: Integer);
    procedure img_OuterColorsMouseLeave(Sender: TObject);
    procedure img_OuterColorsMouseMove(Sender: TObject; Shift: TShiftState; X,
     Y: Integer);
    procedure img_OuterColorsMouseUp(Sender: TObject; Button: TMouseButton;
     Shift: TShiftState; X, Y: Integer);

    procedure DrawColortable;
    img_colortable: TImage;
    bmp_colortable: TBitmap;
    //mappt Farbverlauf auf Gerade

    //++++++++++Innenfärbung++++++++++
    grp_innercolors: TGroupBox;
    cmb_innercolormode: TComboBox;  //Innenfärbung
    procedure cmb_innercolormodeChange(Sender: TObject);
    //itemnindex = 1 - Palette, 2 - Schwarz
    lst_innercolors: TListBox;    //zeigt Palette an
    procedure DrawInnerColors;
    procedure lst_innercolorsDrawItem(Control: TWinControl; Index: Integer;
     ARect: TRect; State: TOwnerDrawState);
    but_InnerColorSave: TButton;  //Speichert / lädt Palette
    procedure but_InnerColorSaveClick(Sender: TObject);
    PaletteSaveDialog: TSaveDialog;
    but_InnercolorLoad: TButton;
    procedure but_InnercolorLoadClick(Sender: TObject);
    PaletteLoadDialog: TOpenDialog;

    //++++++++++Anzeige und OGL-Scrollbox++++++++++
    img_main: TOpenGLControl;

    procedure OGLInit;
    procedure MeasureScrollbars;
    procedure img_mainPaint(Sender: TObject);
    procedure img_mainResize(Sender: TObject);
    //++++++++++Scrollen mit Tastatur++++++++++
    procedure img_mainKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState
     );
    //++++++++++Scrollen mit der Maus++++++++++
    procedure img_mainMouseDown(Sender: TObject; Button: TMouseButton;
     Shift: TShiftState; X, Y: Integer);
    procedure img_mainMouseMove(Sender: TObject; Shift: TShiftState; X,
     Y: Integer);
    procedure img_mainMouseUp(Sender: TObject; Button: TMouseButton;
     Shift: TShiftState; X, Y: Integer);
    procedure img_mainMouseWheelDown(Sender: TObject; Shift: TShiftState;
     MousePos: TPoint; var Handled: Boolean);
    procedure img_mainMouseWheelUp(Sender: TObject; Shift: TShiftState;
     MousePos: TPoint; var Handled: Boolean);

    //++++++++++Statusanzeige++++++++++
    stb_main: TStatusBar;
    procedure stb_mainResize(Sender: TObject);

  public
  //++++++++++Farbpicker++++++++++
    ColorVars: array of TPoint; //enthält die Farbwahlpunkte
    moving: boolean;    //wird gerade einer gedraggt?
    movingVar: integer; //welcher wird gedraggt?
  //++++++++++Anzeige und OGL-Scrollbox++++++++++
    scr_Height, scr_Width: integer;
    scr_posX, scr_posY: GlFloat;
    scr_Y, scr_X: integer;
    dragPosY, dragPosX: GlFloat;
    AlreadyHandled: boolean;
    scr_v: OGLVScrollBar;
    scr_h: OGLHScrollBar;
    vPortHeight, vPortWidth: Glfloat;
    OGLInitialized: boolean;
  end;

var
  FG: TFG;
  Fractal: TFractal;

implementation

//uses ImagingTypes, Imaging, ImagingComponents;
{ TFG }

procedure TFG.FormCreate(Sender: TObject);
begin
     SetExceptionMask([exInvalidOp, exDenormalized, exZeroDivide,
                  exOverflow, exUnderflow, exPrecision]);
     //schaltet fpu - Exceptions aus
     SetPrecisionMode(pmDouble);
     //setzt die Präzession des Coprozessors auf Double (15 Stellen)

     Fractal:=TFractal.Create(MakeComplex(-2.5,1.5),MakeComplex(0.5,-1.5),600,600,250);
     Fractal.LoadInnerColorTable('colortables/default.pal');
     Fractal.SetFormula('Z*Z+C');
     Fractal.SetCriticalPoint('C');

     moving:=false;
     movingvar:=0;

     img_main.DoubleBuffered:=true;
     scr_Height:=0;
     scr_Width:=0;
     Tex.Width:=-1;
     Tex.Height:=-1;
     scr_PosX:=0;
     scr_PosY:=0;
     scr_X:=25;
     scr_Y:=25;
     AlreadyHandled:=false;

     SetLength(ColorVars, 3);
     ColorVars[0].X:=10;
     ColorVars[0].Y:=img_OuterColors.Height div 2;
     ColorVars[1].X:=img_OuterColors.Width div 3;
     ColorVars[1].Y:=img_OuterColors.Height-10;
     ColorVars[2].X:=img_OuterColors.Width-10;
     ColorVars[2].Y:=10;

     DrawInnerColors;
     DrawOuterColors;
     DrawColortable;
     UpdateControls;

     with cmb_innercolormode.Items do
     begin
      Clear;
      Add('Perioden');
      Add('Schwarz');
      Add('Schwarz-Weiss');
      Add('Farbverlauf');
      Add('Argument');
      Add('Argument-Farbverlauf');
      end;
end;

procedure TFG.FormClose(Sender: TObject; var CloseAction: TCloseAction);
var
  i: integer;
begin
  Fractal.Free;
  for i := 0 to High(Tex.Tiles) do
    if Assigned(Tex.Tiles[i].data) then
      System.FreeMem(Tex.Tiles[i].data, sqr(Tex.TileSize)*4);
end;

procedure TFG.UpdateControls;
begin
     ced_centerR.Value:=Fractal.Cen.Real;
     ced_centerI.Value:=Fractal.Cen.Imag;

     ced_sizeR.Value:=Fractal.Width_real;
     ced_sizeI.Value:=Fractal.Height_real;

     ced_size_pixelsR.Value:=Fractal.Width_pixels;
     ced_size_pixelsI.Value:=Fractal.Height_pixels;

     ced_MaxIter.Value:=Fractal.Iterations;

     img_main.Width:=Fractal.Width_pixels;
     img_main.Height:=Fractal.Height_pixels;

     //sed_colordwell.Value:=Fractal.OuterDwellLimit;

     cmb_OutercolorMode.ItemIndex:=Fractal.OuterColMode;
     cmb_InnercolorMode.ItemIndex:=Fractal.InnerColMode;

     sed_colorrepeat.Value:=Fractal.Colorrepeat;

     ced_CenterR.Increment:=Fractal.Width_real/10;
     ced_CenterI.Increment:=Fractal.Height_real/10;

     ced_sizeR.Increment:=Fractal.Width_real/10;
     ced_sizeI.Increment:=Fractal.Height_real/10;

     sed_MinLya.Value:=round(Fractal.LowerBorder);
     sed_MaxLya.Value:=round(Fractal.UpperBorder);

     sed_CycPoints.Value:=Fractal.minCyclePoints;

     sed_Dwell.Value := Fractal.LyapunovDwell;

     cmb_calculatingmode.ItemIndex:=Fractal.calcmode;
end;

procedure TFG.UpdateFractal;
var
   From, Till: TComplex;
begin
     Fractal.Cen:=MakeComplex(ced_centerR.Value,ced_centerI.Value);
     From:=MakeComplex(Fractal.Cen.Real-ced_sizeR.Value/2,
                       Fractal.Cen.Imag+ced_sizeI.Value/2);
     Till:=MakeComplex(Fractal.Cen.Real+ced_sizeR.Value/2,
                       Fractal.Cen.Imag-ced_sizeI.Value/2);
     Fractal.SetSize(From, Till, ced_size_pixelsR.Value, ced_size_pixelsI.Value);
     //Fractal.OuterDwellLimit:=sed_colordwell.Value;
     Fractal.Iterations:=ced_MaxIter.Value;
     Fractal.Outercolmode:=cmb_OuterColorMode.ItemIndex;
     Fractal.Innercolmode:=cmb_InnerColorMode.ItemIndex;
     Fractal.colorrepeat:=sed_colorrepeat.Value;
     Fractal.UpperBorder:=sed_MaxLya.Value;
     Fractal.LowerBorder:=sed_MinLya.Value;
     Fractal.minCyclePoints:=sed_CycPoints.Value;
     Fractal.LyapunovDwell:=sed_Dwell.Value;

     Fractal.Calcmode:=cmb_calculatingmode.itemIndex;
end;

{###########################################################################
 |                              Menu                                       |
 ###########################################################################}
procedure TFG.men_file_loadfractalClick(Sender: TObject);
begin
  if PaletteLoadDialog.Execute then
  begin
    Fractal.LoadFromFile(PaletteLoadDialog.FileName);
    UpdateControls;
  end;
end;

procedure TFG.men_file_savefractalClick(Sender: TObject);
begin
  if PictureSaveDialog.Execute then
  begin
    Fractal.SaveToFile(PictureSaveDialog.FileName);
  end;
end;

procedure TFG.men_file_savebmpClick(Sender: TObject);
var
  T: TPortableNetworkGraphic;
  hndlr: TFPWriterPNG;
  X, Y, i, j, k, count: integer;
begin
  if PictureSaveDialog.Execute then
  begin
    T := TPortableNetworkGraphic.create;
    T.SetSize(Tex.Width, Tex.Height);

    for Y := Tex.Height - 1 downto 0 do
      for X := Tex.Width - 1 downto 0 do
        T.Canvas.Pixels[X,Y] := TColor(Tex.Tiles[X div 512 + (Y div 512) * Tex.nmbrTilesX].data[ X mod 512 + (Y mod 512) * 512]);

    T.SaveToFile(PictureSaveDialog.Filename);
    T.Free;

  end;
end;

procedure TFG.men_tracerClick(Sender: TObject);
begin
   if not Assigned(OrbitTracer) then
    OrbitTracer := TOrbitTracer.Create(self);
  OrbitTracer.Visible := true;
end;

{###########################################################################
 |                        Fractalerzeugung                                 |
 ###########################################################################}

procedure TFG.but_generateClick(Sender: TObject);
begin
     Fractal.StopDrawing;
     UpdateFractal;
     UpdateControls;
     Fractal.Draw;
     img_main.SetFocus;
end;

{###########################################################################
 |                              Parser                                     |
 ###########################################################################}
procedure TFG.but_parseClick(Sender: TObject);
begin
//  mem_ParseDebug.Clear;
  Fractal.StopDrawing;
  //Parsen
  if not Fractal.SetFormula(syned_Formula.Linetext) then
  begin
    syned_Formula.SelStart := FGLastErrorPosition;
    syned_Formula.SelEnd := FGLastErrorPosition+FGLastErrorLength;
    ShowMessage(FGLastErrorMessage);
    exit;
  end;
  if not Fractal.SetCriticalPoint(syned_critical.Linetext) then
  begin
    syned_Critical.SelStart:= FGLastErrorPosition;
    syned_Critical.SelEnd := FGLastErrorPosition+FGLastErrorLength;
    ShowMessage(FGLastErrorMessage);
    exit;
  end;
  //geparste Formeln werden zurückgeschrieben
  syned_Formula.text:=Fractal.Formula;
  syned_critical.text := Fractal.CritPoint;
  ed_Derivate.text:=Fractal.DerivateFormula;
  ed_Derivate2.text:=Fractal.Derivate2Formula;
  ed_DEM.text:=Fractal.DEMFormula;
end;


{###########################################################################
 |                          Außenfärbung                                   |
 ###########################################################################}
procedure TFG.cmb_outercolormodeChange(Sender: TObject);
begin
  UpdateFractal;
  Fractal.Draw;
end;

procedure TFG.sed_colorrepeatChange(Sender: TObject);
begin
     UpdateFractal;
     Fractal.Draw;
end;

procedure TFG.chk_invertcolorsChange(Sender: TObject);
begin
     DrawOuterColors;
     DrawColortable;
     Fractal.Draw;
end;

{###########################################################################
 |                          Farbpicker                                     |
 ###########################################################################}

procedure TFG.DrawOuterColors;
var
  i, j, u: integer;
  hue, light: extended;
  hvalue, dist, OldX, OldY: integer;
  step, way, cosine: extended;
  f, ft, x: extended;
begin
  if HSL_Table=nil then
  begin
    HSL_Table:=TBitmap.Create;
    HSL_Table.Width := img_OuterColors.Width;
    HSL_Table.Height := img_OuterColors.Height;

    light := 0;
    for j := 0 to img_OuterColors.Height - 1 do
    begin
         hue := 0;
         for i := 0 to img_OuterColors.Width - 1 do
         begin
              HSL_Table.Canvas.Pixels[i, j] := //PixelToColor(ClRed32);
              PixelToColor(HSLtoPixel(hue, 1, light));
              hue := hue + 1 / img_OuterColors.Width;
         end;
         light := light + 1 / img_OuterColors.Height;
    end;
    //zeichnet den Farbverlauf
  end;

  img_OuterColors.Canvas.Clear;
  img_OuterColors.Canvas.Draw(0,0, HSL_Table);
  img_OuterColors.Canvas.Brush.Color:=clYellow;
  img_OuterColors.Canvas.Pen.Color:=clBlack;
  img_OuterColors.Canvas.Pen.Width:=1;

  way := 0;
  for j := 0 to High(ColorVars)-1 do
    way += sqrt(sqr(ColorVars[j + 1].X - ColorVars[j].X)+sqr(ColorVars[j + 1].Y - ColorVars[j].Y));
  step := way / (Length_Outer_ColorTable+1);
  //errechnet die "Länge" der Farbkurve im Farbverlauf und berechnet einen
  //"Schritt", also ein 255stel

  u := 0;
  way := ColorVars[0].X;
  OldY := ColorVars[0].Y;
  OldX := ColorVars[0].X;
  dist := abs(ColorVars[u + 1].X - ColorVars[u].X);
  cosine := (ColorVars[1].X - ColorVars[0].X) /
    sqrt(sqr(ColorVars[1].X - ColorVars[0].X)+sqr(ColorVars[1].Y - ColorVars[0].Y));

  for j := 0 to Length_Outer_ColorTable do
  begin
    if (u < High(ColorVars)) and (way >= ColorVars[u + 1].X) then
    begin
      inc(u);
      img_Outercolors.Canvas.Line(OldX,OldY,ColorVars[u].X,ColorVars[u].Y);
      OldY := ColorVars[u].Y;
      OldX := ColorVars[u].X;
      dist := abs(ColorVars[u + 1].X - ColorVars[u].X);
      cosine := (ColorVars[u + 1].X - ColorVars[u].X) /
        sqrt(sqr(ColorVars[u + 1].X - ColorVars[u].X)+sqr(ColorVars[u + 1].Y - ColorVars[u].Y));
    end;

    x := (way - ColorVars[u].X) / dist;
    ft := x * pi;
    f := (1 - cos(ft)) * 0.5;
    hvalue := round(ColorVars[u].Y * (1 - f) + ColorVars[u + 1].Y * f);

    if (j+1) mod 10 = 0 then
    begin
         img_Outercolors.Canvas.Line(OldX,OldY,round(way),hvalue);
         OldX:=round(way);
         OldY:=hvalue;
    end;

    if chk_invertcolors.Checked then
      Fractal.OuterColtable[Length_Outer_ColorTable - j] := HSLtoPixel(way / img_OuterColors.Width, 1, hvalue / img_OuterColors.Height)
    else
      Fractal.OuterColtable[j] := HSLtoPixel(way / img_OuterColors.Width, 1, hvalue / img_OuterColors.Height);

    way := way + step * cosine;
  end;
  //Generiert die Farbtafel

  for j := 0 to High(ColorVars) do
    img_OuterColors.Canvas.Rectangle(ColorVars[j].X + 5, ColorVars[j].Y + 5, ColorVars[j].X - 5, ColorVars[j].Y - 5);

  //Fügt die Farbwählpunkte hinzu
end;

procedure TFG.img_OuterColorsMouseDown(Sender: TObject; Button: TMouseButton;
 Shift: TShiftState; X, Y: Integer);
var
   i, j: integer;
   NotOld: boolean;
begin
     NotOld:=true;
     i:=0;
     while i<=High(ColorVars) do
     begin
          if (abs(ColorVars[i].X-X)+abs(ColorVars[i].Y-Y)<20) then
          begin
               NotOld:=false;
               break;
          end;
          inc(i);
     end;
     if NotOld then
     begin
          i:=0;
          while (i<=High(ColorVars)) and (X>ColorVars[i].X) do
                inc(i);
          SetLength(ColorVars, Length(ColorVars)+1);
          for j:=High(ColorVars) downto i+1 do
              ColorVars[j]:=ColorVars[j-1];
          ColorVars[i].X:=X; ColorVars[i].Y:=Y;
     end else begin
         if Button=mbRight then
         begin
              for i:=i to High(ColorVars)-1 do
                  ColorVars[i]:=ColorVars[i+1];
              SetLength(ColorVars, Length(ColorVars)-1);
         end else begin
             movingvar:=i;
             moving:=true;
         end;
     end;
     DrawOuterColors;
end;

procedure TFG.img_OuterColorsMouseLeave(Sender: TObject);
begin
 if moving=false then exit;
 moving:=false;
 movingvar:=0;
 DrawColortable;
 Fractal.Draw;
end;

procedure TFG.img_OuterColorsMouseMove(Sender: TObject; Shift: TShiftState; X,
 Y: Integer);
begin
     if moving=true then begin
        if (X<0) or (X>img_OuterColors.Width) or (Y<0) or (Y>img_Outercolors.Height) then exit;
        if (movingvar>0) and (X<=ColorVars[movingvar-1].X) then exit;
        if (movingvar<High(ColorVars)) and (X>=ColorVars[movingvar+1].X) then exit;
        if (abs(ColorVars[movingvar].X-X)+abs(ColorVars[movingvar].Y-Y)<10) then exit;
        ColorVars[movingvar].X:=X;
        ColorVars[movingvar].Y:=Y;
        DrawOuterColors;
     end;
end;

procedure TFG.img_OuterColorsMouseUp(Sender: TObject; Button: TMouseButton;
 Shift: TShiftState; X, Y: Integer);
begin
 moving:=false;
 movingvar:=0;
 DrawColortable;
 Fractal.Draw;
end;

procedure TFG.DrawColortable;
//Zeichnet den äußeren Farbverlauf in img_colortable
var
  i: integer;
  w, h: integer;
begin
  img_ColorTable.Canvas.Clear;
  w := img_colortable.Width;
  h := img_colortable.Height;
  for i := 0 to w-1 do
  begin
    img_colortable.Canvas.Pen.Color:=PixelToColor(Fractal.OuterColtable[round(i/(w-1)*Length_Outer_Colortable)]);
    img_colortable.Canvas.Line(i,0,i,h);
  end;
  img_colortable.Canvas.Changed;
end;

{###########################################################################
 |                          Innenfärbung                                   |
 ###########################################################################}

procedure TFG.cmb_innercolormodeChange(Sender: TObject);
begin
     UpdateFractal;
     Fractal.Draw;
end;

procedure TFG.DrawInnerColors;
var
   i: integer;
begin
     lst_innercolors.Clear;
     for i:=0 to Length_Inner_Colortable do
         lst_innercolors.Items.Add('           Periode '+IntToStr(i+1));
end;

procedure TFG.lst_innercolorsDrawItem(Control: TWinControl; Index: Integer;
 ARect: TRect; State: TOwnerDrawState);
begin
     if (Index<0) or (Index>Length_Inner_ColorTable) then exit;
     with Control as TListbox do
     begin
          Canvas.Brush.Color:=PixelToColor(Fractal.InnerColTable[Index]);
          Canvas.Rectangle( ARect.left + 7, ARect.Top + 2,
                            ARect.Left + abs(Arect.Top-ARect.Bottom) +3, ARect.Bottom - 2);
     end;
end;

procedure TFG.but_InnerColorSaveClick(Sender: TObject);
begin
  if PaletteSaveDialog.Execute then
    Fractal.SaveInnerColorTable(PaletteSaveDialog.FileName);
end;

procedure TFG.but_InnercolorLoadClick(Sender: TObject);
begin
  if PaletteLoadDialog.Execute then
    Fractal.LoadInnerColorTable(PaletteLoadDialog.FileName);
end;

{###########################################################################
 |                          OGLScrollBox                                   |
 ###########################################################################}

procedure TFG.OGLInit;
var
   R,G,B: GLclampf;
begin
  OGLInitialized:=true;

  Tex.Width := 0;
  Tex.Height := 0;

  MeasureScrollBars;
  scr_V.Position:=0;
  scr_H.Position:=0;

  {glEnable(GL_DEPTH_TEST);
  glDepthFunc(GL_LESS);}
  //Tiefenbuffer
  glDisable(GL_ALPHA_TEST);
  glDisable(GL_DEPTH_TEST);
  glEnable(GL_CULL_FACE);
  glCullFace(GL_BACK);
  //Backface-Culling

  B := 236 / 255; //1 - ((clBtnFace and $FF0000) shr 16) / 255;
  G := 235 / 255; //1 - ((clBtnFace and $FF00) shr 8) / 255;
  R := 234 / 255; //1 - (clBtnFace and $FF) / 255;
  //durch clBtnFace gtk2 ersetzt

  glClearColor(R,G,B, 1);

  glEnable(GL_LINE_SMOOTH);
  glHint(GL_LINE_SMOOTH_HINT, GL_NICEST);

  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
  glMatrixMode (GL_PROJECTION);
  glLoadIdentity;
  glViewport(0,0,img_main.Width, img_main.Height);
  glOrtho(0, img_main.Width, img_main.Height, 0, 0, 128);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity;

end;

procedure TFG.MeasureScrollbars;
var
  imgWidth, imgHeight: Glfloat;
begin
  scr_PosY := 0;
  scr_PosX := 0;

  imgWidth:=img_main.Width;
  imgHeight:=img_main.Height;

  with scr_v do
  begin
    Width:=15;
    Left:=imgWidth-Width-2;
    ButtonHeight:=15;
    TopButton:=2;
    LowerButton:=imgHeight-ButtonHeight-2;
    roundEdge:=ButtonHeight/4;
    dragState:=false;
    dragPos:=0;
    Enabled := false;
    Visible := false;
    Position := 0;
  end;
  with scr_h do
  begin
    Height:=15;
    LeftButton:=2;
    ButtonWidth:=15;
    roundEdge:=ButtonWidth/4;
    Top:=imgHeight-Height-2;
    dragState:=false;
    dragPos:=0;
    Enabled := false;
    Visible := false;
    Position := 0;
  end;
  //Positionen der Scrollbars setzen

  if imgHeight < scr_Height then
  begin
       scr_V.Enabled := true;
       if scr_V.Left < scr_Width then scr_H.Enabled := true;
  end else if imgWidth < scr_Width then
  begin
    scr_H.Enabled := true;
    if scr_H.Top < scr_Height then scr_V.Enabled := true;
  end;
  //Prüfen welche Scrollbars aktiv sind

  if scr_V.Enabled then vPortWidth := scr_V.Left - 2
  else vPortWidth := imgWidth;
  if scr_H.Enabled then vPortHeight := scr_H.Top - 2
  else vPortHeight := imgHeight;
  //den letztendlichen Sichtbereich setzen

  if scr_V.Enabled then
  begin
       scr_V.Visible:=true;
       scr_V.scrRelation := (imgHeight - 2 * scr_v.ButtonHeight - 4) / scr_Height;
       scr_V.pageSize := scr_V.scrRelation * vPortHeight;
  end;
  if scr_H.Enabled then
    with scr_H do
    begin
      Visible:=true;
      RightButton := vPortWidth - ButtonWidth - 4;
      scrRelation := (RightButton - (LeftButton+ButtonWidth)) / scr_Width;
      PageSize := scrRelation * vPortWidth;
    end;
  //Paddle-Size von beiden Scrollbars so anpassen, dass tatsächlich über das
  //ganze Bild gescrollt wird: Paddle / Scrolllänge = Viewport / Bildlänge
end;

procedure TFG.img_mainPaint(Sender: TObject);
var
   X, Y, X2, Y2: GLFloat;
   TX1, TX2, TY1, TY2: GLFloat;
   i, j: integer;
begin
  if not OGLInitialized then OGLInit;
  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);

  glEnable(GL_TEXTURE_2D);
  glColor3f(1, 1, 1);

  //if Length(Tex.Tiles) = 0 then exit;

  Y := scr_PosY;
  for i := 0 to Tex.nmbrTilesY-1 do
  begin
    X := scr_PosX;
    for j := 0 to Tex.nmbrTilesX-1 do
    begin
      glBindTexture(GL_TEXTURE_2D, Tex.Tiles[i*Tex.nmbrTilesX+j ].ID);
      glBegin(GL_QUADS);
        glTexCoord2f(0,0); glVertex3f(X, Y, -10);
        glTexCoord2f(0,1); glVertex3f(X, Y + Tex.TileSize, -10);
        glTexCoord2f(1,1); glVertex3f(X + Tex.TileSize, Y + Tex.TileSize, -10);
        glTexCoord2f(1,0); glVertex3f(X + Tex.TileSize, Y, -10);
      glEnd;
      X := X + Tex.TileSize;
    end;
    Y := Y + Tex.TileSize;
  end;

  {X2 := vPortWidth;
  Y2 := vPortHeight;

  TX1 := abs(scr_posX)/Tex.Width;
  TX2 := Min(abs(scr_posX)+vPortWidth,Tex.Width)/Tex.Width;
  TY1 := abs(scr_posY)/Tex.Height;
  TY2 := Min(abs(scr_posY)+vPortHeight,Tex.Height)/Tex.Height;

  glEnable(GL_TEXTURE_2D);

  glColor3f(1, 1, 1);
  glBegin(GL_QUADS);
    glTexCoord2f(TX1,TY1); glVertex3f(0, 0, -10);
    glTexCoord2f(TX1,TY2); glVertex3f(0, Y2, -10);
    glTexCoord2f(TX2,TY2); glVertex3f(X2, Y2, -10);
    glTexCoord2f(TX2,TY1); glVertex3f(X2, 0, -10);
  glEnd;}

  glDisable(GL_TEXTURE_2D);

  glColor3f(233/255,234/255,235/255);
  //Hintergrund für Scrollbars
  glBegin(GL_QUADS);
    glVertex3f(0, img_main.Height, -1);
    glVertex3f(img_main.Width, img_main.Height, -1);
    glVertex3f(img_main.Width, vPortHeight, -1);
    glVertex3f(0, vPortHeight, -1);

    glVertex3f(vPortWidth, 0, -1);
    glVertex3f(vPortWidth, img_main.Height, -1);
    glVertex3f(img_main.Width, img_main.Height, -1);
    glVertex3f(img_main.Width, 0, -1);
  glEnd;

  if scr_v.Visible then DrawVScrollBar(scr_v);
  if scr_h.Visible then DrawHScrollBar(scr_h);

  img_main.SwapBuffers;
end;

procedure TFG.img_mainResize(Sender: TObject);
begin
  OGLInitialized:=false;
  img_main.Invalidate;
end;

procedure TFG.img_mainKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState
 );
begin
 case Key of
      VK_DOWN: if ScrollY(scr_v, 35) then img_Main.Invalidate;
      VK_UP:   if ScrollY(scr_v, -35) then img_Main.Invalidate;
      VK_LEFT: if ScrollH(scr_h, -35) then img_Main.Invalidate;
      VK_RIGHT:if ScrollH(scr_h, 35) then img_Main.Invalidate;
  end;
end;

procedure TFG.img_mainMouseDown(Sender: TObject; Button: TMouseButton;
 Shift: TShiftState; X, Y: Integer);
begin
  if (X >= vPortWidth) and (scr_V.Enabled) and
    (Y>scr_v.TopButton+scr_v.ButtonHeight+scr_V.Position) and
    (Y<scr_v.TopButton+scr_v.ButtonHeight+scr_V.Position+scr_V.pageSize) then
  begin
    scr_V.dragPos:=Y - (scr_v.TopButton+scr_v.ButtonHeight+scr_V.Position);
    scr_V.dragState:=true;
  end else if (Y >= vPortHeight) and (scr_H.Enabled) and
    (X > scr_H.LeftButton + scr_H.ButtonWidth + scr_H.Position) and
    (X < scr_H.LeftButton + scr_H.ButtonWidth + scr_H.Position + scr_H.pageSize) then
  begin
    scr_H.dragPos:=X - (scr_H.LeftButton + scr_H.ButtonWidth + scr_H.Position);
    scr_H.dragState:=true;
  end else if (X + abs(scr_PosX) < Fractal.Width_pixels) and
    (Y + abs(scr_PosY) < Fractal.Height_pixels) then
  begin
     Fractal.StopDrawing;
     if Button=mbleft then Fractal.Zoom(3, Point(X,Y))
     else if Button=mbright then Fractal.Zoom(0.333, Point(X,Y));
     Fractal.Draw;
     UpdateControls;
  end;
end;

procedure TFG.img_mainMouseMove(Sender: TObject; Shift: TShiftState; X,
 Y: Integer);
begin
  if (scr_V.dragState=true) then
  begin
    if ScrollY(scr_V, Y - scr_V.TopButton - scr_V.ButtonHeight - scr_V.Position - scr_V.dragPos)
      then img_Main.Invalidate;
  end else if (scr_H.dragState=true) then
  begin
    if ScrollH(scr_H, X - scr_H.LeftButton - scr_H.ButtonWidth - scr_H.Position - scr_H.dragPos) then
      img_main.Invalidate;
  end else if (X < vPortWidth) and (Y < vPortHeight) then
  begin
    X := X + round(abs(scr_posX));
    Y := Y + round(abs(scr_posY));
    stb_main.Panels[0].Text:=CompToStr(Fractal.PointToComp(Point(X,Y)))+'   Periode: '+
                          IntToStr(Fractal.period[X,Y])+'   Lyapunov-Exponent: '+
                          FloatToStr(Fractal.lyapunov[X,Y])+ '     Iterationen: ' +
                          IntToStr(Fractal.Iterated[X,Y]) + '     Distanz: ' +
                          FloatToStr(Fractal.Distance[X,Y]);
  end;
end;

procedure TFG.img_mainMouseWheelDown(Sender: TObject; Shift: TShiftState;
 MousePos: TPoint; var Handled: Boolean);
begin
  if (scr_v.Enabled and ScrollY(scr_v, +35)) or
    (scr_H.Enabled and ScrollH(scr_H, +35)) then img_Main.Invalidate;
end;

procedure TFG.img_mainMouseWheelUp(Sender: TObject; Shift: TShiftState;
 MousePos: TPoint; var Handled: Boolean);
begin
  if (scr_v.Enabled and ScrollY(scr_v, -35)) or
    (scr_H.Enabled and ScrollH(scr_H, -35)) then img_Main.Invalidate;
end;

procedure TFG.img_mainMouseUp(Sender: TObject; Button: TMouseButton;
 Shift: TShiftState; X, Y: Integer);
begin
  if scr_V.dragState then scr_V.dragState:=false;
  if scr_H.dragState then scr_H.dragState:=false;
end;

{###########################################################################
 |                          Statusbar                                      |
 ###########################################################################}

procedure TFG.stb_mainResize(Sender: TObject);
begin
 stb_main.Panels[0].Width:=ClientWidth-MainPage.Width;
end;

initialization
  {$I utfractalgenerator.lrs}

end.

